#
# Accommodation - using M1 Structure
# Created by Milko Minchev
# with the kind cooperation of Konrad Zylkovski and Tomasz Lisowski
#
# This is MBM Open Source Accomodation project for Tribon
# for details please visit http://www.mbmproject.com/open-source-accommodation.php
#
import kcs_ui
print '1'
import kcs_util
print '2'
import KcsStringlist
import kcs_struct
import KcsPoint3D
import KcsVector3D
import kcs_draft
import KcsPoint2D
import KcsContour2D
import KcsModel
import ACCWall2Points
import ACCAddFurniture
import string
import Components

OK = kcs_util.ok()
CANCEL = kcs_util.cancel()

modTxt = "Module : "
modName = '512'
rhTxt = "Room Height : "
Height = 2100.0
cnTxt = "Ceiling Type : "
ceilComp = "CEILPAN-30"
fcTxt = "Floor Coord : "
floorCoord = 32200.0
ceilCoord = floorCoord + Height
wtTxt = "Wall Type : "
wallComp = "WALLPANEL-30"
whTxt = "Wall Height : "
wallHeight = 2200.0

s1 = "TRIBON M1 ACCOMMODATION"
s2 = "http://www.mbmproject.com"
s4 = modTxt + modName # 1
s5 = fcTxt + "%d" %(floorCoord) # 2

s6 = cnTxt + ceilComp # 3
s7 = rhTxt + " %d" %(Height) # 4

s8 = wtTxt + wallComp # 5
s9 = whTxt + "%d" %(wallHeight) # 6

s10 = "Save as default" # 7

s11 = "Room Define" # 8
s12 = "Create Wall" # 9
s13 = "Place Furniture" # 10
Color = 'Blue'

def TestFunction():
   kcs_ui.message_confirm('Test Message')
   
def SetVal(message,string,cmpType):
   try:
      resVal = kcs_ui.string_req(message,string)
      if resVal[0] == kcs_util.ok():
         print 'The entered string is:',resVal[1]
         string = resVal[1]
         print string , "  1  "
         return string
      elif resVal[0] == kcs_util.options():
         comp_data = Components.run(cmpType)
         string = comp_data[0]
         return string
      else:
         print 'User interrupted'
   except:
      print 222
      print kcs_ui.error

def SetReal(message,real):
   try:
      resVal = kcs_ui.real_req(message, real)
      if resVal[0] == kcs_util.ok():
         real = resVal[1]
         return real
      else:
         print 'User interrupted'
   except:
      print 333
      print kcs_ui.error      

def NewStructure(modName, Color):
   try:
      structName = kcs_ui.string_req('Key in name of Room')
      try:
         kcs_struct.struct_new(structName[1],modName,Color)
         print '!!!!!!!!!!!!!!'
         CreateCeiling(ceilCoord)
         model = KcsModel.Model('struct', structName[1])
         kcs_draft.model_draw(model)
      except:
         print kcs_struct.error
         print 'except - struct_new'
         if kcs_struct.error == 'kcs_NameError':
            kcs_ui.message_confirm('Invalid name')
            NewStructure(modName, Color)
         elif kcs_struct.error == 'kcs_ModuleError':
            kcs_ui.message_confirm('Module does not exist')
         elif kcs_struct.error == 'kcs_ModelCurrent':
            kcs_ui.message_confirm('Another model is already current')
         elif kcs_struct.error == 'kcs_ModelFound':
            kcs_ui.message_confirm('The model is already locked for update')
         else:
            pass
   except:
      pass

def CreateCeiling(ceilCoord):
   print "in Ceiling"
   #  Create contour object
   prompt='indicate point (cancel = step back)' 
   first = 0
   while 1:
      point     = KcsPoint2D.Point2D()
      indicate_point=kcs_ui.point2D_req(prompt,point)
      if indicate_point[0]==OK:
         if first == 0:
           points = [point]
           cont      = KcsContour2D.Contour2D(point)
           cont_handle=kcs_draft.contour_new(cont)
           first = 1
         else:
            points.append(point)
            cont.AddLine(point)
         try:
            kcs_draft.element_delete(cont_handle)
            cont_handle=kcs_draft.contour_new(cont)
         except: pass
     # STEP BACK  
      elif indicate_point[0]==CANCEL:
         points.remove(points[-1])  
         cont      = KcsContour2D.Contour2D(points[0])
         try:
            kcs_draft.element_delete(cont_handle)
         except: pass

         for point in points[1:]:
            cont.AddLine(point)
         cont_handle=kcs_draft.contour_new(cont)
      # FINALLY  
      else:
         points.append(points[0])
         cont      = KcsContour2D.Contour2D(points[0])
         try:
            kcs_draft.element_delete(cont_handle)
         except: pass

         for point in points[1:]:
            cont.AddLine(point)
         cont_handle=kcs_draft.contour_new(cont)
         break
    
   kcs_draft.element_delete(cont_handle)
   modelPoint = KcsPoint2D.Point2D()
   first = 0
   for pnt in points:
      traPoint = kcs_util.tra_coord_ship(pnt.X,pnt.Y,"")
      modelPoint.X = traPoint[1]
      modelPoint.Y = traPoint[2]
      if first == 0:
         contour = KcsContour2D.Contour2D(modelPoint)
         first = 1
      else:
         contour.AddLine(modelPoint)     
   try:
      print "in TRY"
      #plateComp = kcs_ui.string_req('Key in Component name')
      oriPoint  = KcsPoint3D.Point3D(0, 0, ceilCoord)
      normal    = KcsVector3D.Vector3D(0.0, 0.0, 1.0)
      rotation  = KcsVector3D.Vector3D(1.0, 0.0, 0.0)
      try:
         platePart = kcs_struct.plate_new_contour2D(ceilComp, oriPoint, normal, rotation, contour)
      except:
         print kcs_struct.error
         print 'except - plate_new'
         if kcs_struct.error == 'kcs_FunctionInvalid':
            kcs_ui.message_confirm('Invalid Function')
         elif kcs_struct.error == 'kcs_ModelNotCurrent':
            kcs_ui.message_confirm('No current structure')
         elif kcs_struct.error == 'kcs_ComponentInvalid':
            kcs_ui.message_confirm('Invalid Component')
         elif kcs_struct.error == 'kcs_NoPart':
            kcs_ui.message_confirm('It was not possible to create a part')
         else:
            print 'Another error'
   except:
      print 'except - plate data preparation'
   try:
      save = kcs_struct.struct_save()
      print 'Structure ready and saved'
   except:
      print 'Error when saving structure'
      print kcs_struct.error

########################################################
##
## WriteIniFile() function
## stores changed parameters in default file
##
## default file CA_ACC_DEF must be available
## default file name is ca_acc.def (in SB_SHIP directory)
##
## IniParser module must be available
########################################################
def WriteIniFile():
    import IniParser
    section='DEFAULTS'
    try:
        file_name=kcs_util.TB_environment_get('CA_ACC_DEF')
    except:
        print 'Variable CA_ACC_DEF not defined, trying to find file "ca_acc.def" in SB_SHIP directory'
        try:
            file_name=kcs_util.TB_environment_get('SB_SHIP') + '\\ca_acc.def'
        except:
            print 'Default directory not assigned'
    try:
        try: FLOOR_COORDINATE=floorCoord
        except: FLOOR_COORDINATE=None
        try: ROOM_HEIGHT = Height
        except: ROOM_HEIGHT = None
        try: WALL_HEIGHT = wallHeight
        except: WALL_HEIGHT = None
        try: CEILING_TYPE = ceilComp
        except: CEILING_TYPE = None
        try: WALL_TYPE = wallComp
        except: WALL_TYPE = None
        try: ROOM_COLOR = Color
        except: ROOM_COLOR = None
        try: MODULE = modName
        except: MODULE = None

        params=[FLOOR_COORDINATE,ROOM_HEIGHT, WALL_HEIGHT, CEILING_TYPE,WALL_TYPE, ROOM_COLOR, MODULE]
        option_names=['FLOOR_COORDINATE','ROOM_HEIGHT', 'WALL_HEIGHT', 'CEILING_TYPE','WALL_TYPE', 'ROOM_COLOR', 'MODULE']
        dict={}
        for i in range(len(params)):
            dict[option_names[i]]=params[i]
        
        ini=IniParser.IniParser()
        ini.read(file_name)
        for opt in dict.keys():
            if dict[opt] <> None:
              ini.remove_option(section, opt)
              ini.set(section, opt,dict[opt])
        file=open(file_name, 'w')
        ini.write(file)
    finally:
        file.close()      
      
########################################################################
########################################################
##
## ReadIniFile() function
##
## reads default file
## default file CA_ACC_DEF must be available
## default file name is ca_acc.def (in SB_SHIP directory)
##
## returns a dictionary
## {'FLOOR_COORDINATE':<value>, 'ROOM_HEIGHT':<value>, ...etc}
##
## IniParser module must be available
########################################################
def ReadIniFile():
    import IniParser
    section='DEFAULTS'
    try:
        file_name=kcs_util.TB_environment_get('CA_ACC_DEF')
    except:
        print 'Variable CA_ACC_DEF not defined, trying to find file "ca_acc.def" in SB_SHIP directory'
        try:
            file_name=kcs_util.TB_environment_get('SB_SHIP') + '\\ca_acc.def'
        except:
            print 'Default directory not assigned'
    try:
        dict={}       
        ini=IniParser.IniParser()
        ini.read(file_name)
        opt=ini.options(section)
        for i in range(len(opt)):
            val=ini.get(section,opt[i])
            dict[opt[i]]=val
        return dict
    except:
        print 'Error opening default file'
###
dict=ReadIniFile()
modName=dict['MODULE']
floorCoord=float(dict['FLOOR_COORDINATE'])
ceilComp=dict['CEILING_TYPE']
Height=float(dict['ROOM_HEIGHT'])
wallComp=dict['WALL_TYPE']
wallHeight=float(dict['WALL_HEIGHT'])
ceilCoord = floorCoord + Height
#####
s4 = modTxt + modName # 1
s5 = fcTxt + "%d" %(floorCoord) # 2
s6 = cnTxt + ceilComp # 3
s7 = rhTxt + " %d" %(Height) # 4
s8 = wtTxt + wallComp # 5
s9 = whTxt + "%d" %(wallHeight) # 6
############################################################################
#
# Command selection
#
execute = 1
while(execute):
   slist = KcsStringlist.Stringlist(s4)
   slist.AddString(s5)
   slist.AddString(s6)
   slist.AddString(s7)
   slist.AddString(s8)
   slist.AddString(s9)
   slist.AddString(s10)
   slist.AddString(s11)
   slist.AddString(s12)
   slist.AddString(s13)
   try:
      res = kcs_ui.choice_select(s1,s2,slist)
      if res[0] == kcs_util.ok():
         print 'Your selection: Choice no',res[1]
         if res[1] == 1:
            message='Please key in MODULE name'
            modName = SetVal(message,modName)
            s4 = modTxt + modName
         elif res[1] == 2:
            message='Please key in Floor Z-coordinate'
            floorCoord = SetReal(message,floorCoord)
            ceilCoord = floorCoord + Height
            s5 = fcTxt + "%d" %(floorCoord)  
         elif res[1] == 3:
            message='Please key in Ceiling Component'
            cmpType = "ACC1"
            ceilComp = SetVal(message,ceilComp, cmpType)
            s6 = cnTxt + ceilComp
         elif res[1] == 4:
            message='Please key in Room Height'
            Height = SetReal(message,Height)
            ceilCoord = floorCoord + Height
            s7 = rhTxt + "%d" %(Height)
         elif res[1] == 5:
            message='Please key in Wall Component'
            cmpType="ACC2"
            wallComp = SetVal(message,wallComp,cmpType)
            s8 = wtTxt + wallComp
         elif res[1] == 6:
            message='Please key in Wall Height'
            wallHeight = SetReal(message,wallHeight)
            s9 = whTxt + "%d" %(wallHeight)
         elif res[1] == 7:
            WriteIniFile()
         elif res[1] == 8:
            NewStructure(modName, Color)
         elif res[1] == 9:
            ACCWall2Points.Wall2Points(wallComp, floorCoord, wallHeight, point_ver=0, wall_ver=1)
         elif res[1] == 10:
            ACCAddFurniture.Place(floorCoord)
         else:
            pass 
      elif res[0] == kcs_util.cancel():
         print 'You pressed CANCEL or REJECT'
         execute=0
      elif res[0] == kcs_util.options():
         print 'You pressed OPTIONS'
      elif res[0] == kcs_util.quit():
         print 'You pressed EF (QUIT)'
         execute=0
      elif res[0] == kcs_util.operation_complete():
         print 'You pressed OPERATION COMPLETE'
         execute=0
      else:
         print 'You pressed some other interrupting button'
   except:
      print 111
      print kcs_ui.error


