import string
import kcs_draft
import KcsPoint2D
import kcs_ui
import KcsModel
import kcs_dex
import kcs_util
import KcsStringlist

OK = kcs_util.ok()
CANCEL = kcs_util.cancel()

def ModelCheck(name,part):  # Looking for CEILING PANEL - COMPONENTTYPE == "ACC1"
    compNames=[]
    ceilFound = 0
    query = 'STRUCTURE.ITEM(' + name + ').GROUP(1).PART(1:1000).COMP_NAME' # Get COMPONENT NAME
    kcs_dex.extract(query)
    type = kcs_dex.next_result()
    while type > 0:
      if type == 3:
        componentName=kcs_dex.get_string()
        commandStr=kcs_dex.get_commandstring()
        compNames.append(componentName)
       # print commandStr
        pos1=string.find(commandStr,'.PART(') # Get the corresponding PART ID
        pos1+=6
        pos2=string.find(commandStr,').COMP_NAME')
        part=commandStr[pos1:pos2] # The PART ID 
       # print part
       # print componentName
        type = kcs_dex.next_result()
    print compNames
    for i in compNames:
        componentName = i
        query = 'COMPONENT(\'' + componentName + '\').GEN_PROPERTY.TYPE' # GET COMPONENT TYPE
        print query
        kcs_dex.extract(query)
        type = kcs_dex.next_result()
        if type == 3:
            type=kcs_dex.get_string()
            print type
            if type == "ACC1":
                if ceilFound == 1:
                    message_confirm('The room consists of more than one ceiling! Please verify the model.')
                else:
                    ceilFound = 1
                RoomArea(name, part)
        else:
            kcs_ui.message_confirm('No suitable component found')

def RoomArea(name, part): # Get room's AREA
    print 'BEGIN AREA'
    query = 'STRUCTURE.ITEM(' + name + ').GROUP(1).PART(' + part +').AREA'
    print query
    kcs_dex.extract(query)
    type = kcs_dex.next_result()
    while type >= 0:
      if type == 2:
        area=kcs_dex.get_real()
        area = area / 1000000
        str_area = "%.2f" % (area)
        print str_area
        type = kcs_dex.next_result()

    message = 'Room : ' + name + '  Area : ' + str_area + '\n' # Message on the screen
    message+= 'Please locate the text or CANCEL to exit'
    dwgtext = name + ' \n ' + str_area + '\n' # Text on the Drawing
    try:
      coord = KcsPoint2D.Point2D()
      res = kcs_ui.point2D_req(message, coord)
      if res[0] == kcs_util.ok():
        try:
          text_handle = kcs_draft.text_new(dwgtext,coord)
        except:
          print kcs_draft.error
      else:
        print "User interrupted"
    except:
      print kcs_draft.error        

execute=1        
message="Indicate Ceiling Panel"
while(execute):
    try:
        point=KcsPoint2D.Point2D()
        res=kcs_ui.point2D_req(message,point)
        if res[0] != OK:
            execute=0
    except:
        kcs_util.cancel()
        print kcs_draft.error
    try:
        model = KcsModel.Model('struct')
        res=kcs_draft.model_identify(point, model)
        print res[0]
        #s = "%s '%s'" % (model.Type, model.Name)
        name = "'%s'" % (model.Name)
        part = "%s" % (model.PartId)
        print 111
        ModelCheck(name, part)
    except:
        print kcs_draft.error
        if kcs_draft.error == 'kcs_ModelNotfound':
            kcs_ui.message_confirm('No model found')
        





    