#
# Add Furniture to existing room - Accommodation subscript- using M1 Structure
# Created by Milko Minchev
# with the kind cooperation of Konrad Zylkovski and Lyudmil Stoev
#
import string
import kcs_draft
import KcsPoint2D
import kcs_ui
import KcsModel
import kcs_dex
import kcs_util
import KcsStringlist
import kcs_struct
import KcsPoint3D
import KcsVector3D
import Components

OK = kcs_util.ok()
CANCEL = kcs_util.cancel()

def ModelCheck(model,name,part,floorCoord,furnitureComp):  # Looking for CEILING PANEL - COMPONENTTYPE == "1"
    print "in ModelCheck"
    compNames=[]
    ceilFound = 0
    query = 'STRUCTURE.ITEM(' + name + ').GROUP(1).PART(1:1000).COMP_NAME' # Get COMPONENT NAME
    kcs_dex.extract(query)
    type = kcs_dex.next_result()
    while type > 0:
      if type == 3:
        componentName=kcs_dex.get_string()
        commandStr=kcs_dex.get_commandstring()
        compNames.append(componentName)
       # print commandStr
        pos1=string.find(commandStr,'.PART(') # Get the corresponding PART ID
        pos1+=6
        pos2=string.find(commandStr,').COMP_NAME')
        part=commandStr[pos1:pos2] # The PART ID 
       # print part
       # print componentName
        type = kcs_dex.next_result()
    print compNames
    for i in compNames:
        componentName = i
        query = 'COMPONENT(\'' + componentName + '\').GEN_PROPERTY.TYPE' # GET COMPONENT TYPE
        print query
        kcs_dex.extract(query)
        type = kcs_dex.next_result()
        if type == 3:
            type=kcs_dex.get_string()
            print type
            if type[:3] == "ACC":
                name = name[1:]
                name = name[:-1]
                print name
                try:
                    print "in try"
                    kcs_struct.struct_activate(name)
                    message="Room " + name + "activated"
                    kcs_ui.message_noconfirm(message)
                except:
                    print "Error - struct activate   ", name
                    print kcs_struct.error
                    print name
                PlaceFurniture(model,floorCoord,furnitureComp)
                try:
                    save = kcs_struct.struct_save()
                    # by MM on 16.10.2005
                    model=KcsModel.Model('struct', model.Name)
                    kcs_draft.model_draw(model)
                    message="Room " + name + " stored to the data bank"
                except:
                    print 'Error when saving structure'
                    print kcs_struct.error
                break

            else:
                kcs_ui.message_confirm('No suitable component found')            
            

def PlaceFurniture(model,floorCoord,furnitureComp):
    print "in Place Furniture"
    ###
    try:
        message="Indicate Point"
        point=KcsPoint2D.Point2D()
        res=kcs_ui.point2D_req(message,point)
        if res[0] != OK:
            execute=0
    except:
        kcs_util.cancel()
        print kcs_draft.error  
    try:
      plateComp = furnitureComp
      modelPoint = KcsPoint2D.Point2D()
      traPoint = kcs_util.tra_coord_ship(res[1].X,res[1].Y,"")
      modelPoint.X = traPoint[1]
      modelPoint.Y = traPoint[2]
      print modelPoint.X , modelPoint.Y
      oriPoint  = KcsPoint3D.Point3D(modelPoint.X, modelPoint.Y, floorCoord)
      print oriPoint
      normal    = KcsVector3D.Vector3D(0.0, 0.0, 1.0)
      rotation  = KcsVector3D.Vector3D(0.0, 1.0, 0.0)
      # by MM on 16.10.2005
      model=KcsModel.Model('struct', model.Name)
      try:
         kcs_struct.misc_comp_new (plateComp, oriPoint, normal, rotation)
         kcs_draft.model_draw(model)
         print "furniture should be placed"
      except:
         print 'Error : new structure component'
         print kcs_struct.error
    except:
      print 'Error : furniture place'
      print kcs_struct.error

def Place(floorCoord):
    print "floorcoord 1 : " , floorCoord
    message="Key in Furniture component name"
    print message
    try:
        print "in try"
        resVal = kcs_ui.string_req(message)
        if resVal[0] == kcs_util.ok():
            print 'The entered string is:',resVal[1]
            furnitureComp = resVal[1]
        elif resVal[0] == kcs_util.options():
            comp_data = Components.run("ACC3")
            furnitureComp = comp_data[0]
        else:
            print 'User interrupted'
    except:
        print "except furnitureComp"
        print kcs_ui.error
    execute=1
    while(execute):
        message="Indicate Ceiling Panel"
        try:
            point=KcsPoint2D.Point2D()
            res=kcs_ui.point2D_req(message,point)
            if res[0] != OK:
                execute=0
                break
        except:
            kcs_util.cancel()
            print kcs_draft.error
        try:
            model = KcsModel.Model('struct')
            res=kcs_draft.model_identify(point, model)
            print res[0]
            #s = "%s '%s'" % (model.Type, model.Name)
            name = "'%s'" % (model.Name)
            part = "%s" % (model.PartId)
            print "----------------"
            ModelCheck(model,name, part, floorCoord,furnitureComp)
        except:
            print kcs_draft.error
            if kcs_draft.error == 'kcs_ModelNotfound':
                kcs_ui.message_confirm('No model found')

###Place(floorCoord)
