# Function to create room walls
# by 2 coursor points
# Konrad Zylkowski, 21.11.01
#
# input: component name (string), Z- coordinate (real), H - wall height (real),
# ver - point verification ON/OFF (int)
#
import kcs_util
import kcs_ui
import kcs_draft
import kcs_struct
import KcsPoint3D
import KcsVector3D
import KcsVector2D
import KcsPoint2D
import KcsContour2D
import KcsModel
import KcsCircle2D
import math

OK = kcs_util.ok()
YES = kcs_util.yes()
NO  = kcs_util.no()
CANCEL = kcs_util.cancel()


def Wall2Points(component, Z, H, point_ver=1, wall_ver=1):
    try:
        kcs_struct.struct_cancel()
    except:
        pass
    new_room=1
    while new_room==1:
        model=KcsModel.Model('struct')
        
        status = CANCEL
        try:
            cabin_point=KcsPoint2D.Point2D()
            indicate=kcs_ui.point2D_req('Indicate Room',cabin_point)
            if indicate[0]==OK:
                kcs_draft.model_identify(cabin_point, model)
            else:
                new_room=0
            structName = model.Name
            # by MM on 15.10.2005
            model=KcsModel.Model('struct', structName)
            try: # Activate structure
                kcs_struct.struct_activate(structName)
                status = OK
                kcs_ui.message_noconfirm('Room ' + structName + ' is current')
            except:
                print "Error when activating structure!"
                print kcs_struct.error
        except:
            print "General failure!"

        if status == OK:
          status = CANCEL
          #  Create a plate 
          try:
            plateComp = component
            oriPoint  = KcsPoint3D.Point3D()
            normal    = KcsVector3D.Vector3D()
            rotation  = KcsVector3D.Vector3D()
            vert    = KcsVector3D.Vector3D(0,0,1)
            
            new_wall=1         
            while new_wall==1:          
                #  Create contour object
                #First point
                cont=1
                while cont==1:
                    try:
                        kcs_draft.element_delete(handle)
                    except: pass
                    prompt='indicate first point'
                    point1     = KcsPoint2D.Point2D()
                    indicate_point1=kcs_ui.point2D_req(prompt,point1)
                    if indicate_point1[0]==OK:
                        handle=kcs_draft.point_new(point1)
                        if point_ver==1:
                            if kcs_ui.answer_req('Point verification','OK ?')==YES:             
                                cont=0
                        else:
                            cont=0
                    else:
                        cont=0
                        new_wall=0
                # Second point
                cont=1
                while cont==1 and new_wall==1:
                    try:
                        kcs_draft.element_delete(handle)
                    except: pass
                    prompt='indicate second point'
                    point2     = KcsPoint2D.Point2D()
                    indicate_point2=kcs_ui.point2D_req(prompt,point2)
                    if indicate_point2[0]==OK:
                        handle=kcs_draft.point_new(point2)
                        if point_ver==1:
                            if kcs_ui.answer_req('Point verification','OK ?')==YES:
                                kcs_draft.element_delete(handle)
                                cont=0
                        else:
                            kcs_draft.element_delete(handle)
                            cont=0
                            
                    else:
                        cont=1
                if new_wall==1:

                    traPoint1 = kcs_util.tra_coord_ship(point1.X ,point1.Y,'')
                    traPoint2 = kcs_util.tra_coord_ship(point2.X ,point2.Y,'')

                    normal    = KcsVector3D.Vector3D(traPoint2[1]-traPoint1[1],traPoint2[2]-traPoint1[2], 0)
                    rotation  = KcsVector3D.Vector3D(traPoint2[1]-traPoint1[1],traPoint2[2]-traPoint1[2], 0)

                    normal.Rotate(-(math.pi)/2,vert)
                    
                    l=math.sqrt( (traPoint2[1] - traPoint1[1])**2 +   (traPoint2[2] - traPoint1[2])**2 )
                    stru_p1=  KcsPoint2D.Point2D(0,0)
                    stru_p2=  KcsPoint2D.Point2D(l,0)
                    stru_p3=  KcsPoint2D.Point2D(l,H)
                    stru_p4=  KcsPoint2D.Point2D(0,H)

                    cont=KcsContour2D.Contour2D(stru_p1)
                    cont.AddLine(stru_p2)
                    cont.AddLine(stru_p3)
                    cont.AddLine(stru_p4)
                    cont.AddLine(stru_p1) 

                    oriPoint.SetCoordinates(traPoint1[1], traPoint1[2], Z)
                    try:
                      platePart = kcs_struct.plate_new_contour2D(plateComp, \
                                 oriPoint, normal, rotation, cont)
                      status = OK
                      kcs_draft.model_draw(model)
                      if wall_ver==1:
                          if kcs_ui.answer_req('Wall verification','Wall OK ?')==NO:
                              kcs_struct.part_delete(platePart)
                              kcs_draft.model_draw(model)
                    except:
                      print kcs_struct.error

          except:
                print kcs_struct.error
                            
        #  Save the structure
        if status == OK:
          try:
            save = kcs_struct.struct_save()
            kcs_draft.model_draw(model)
            print 'Structure ready and saved'
          except:
            print 'Error when saving structure'
            print kcs_struct.error
    try:
        kcs_struct.struct_cancel()
    except:
        pass
        
                      
###########################################################################

# this section can be removed
if __name__ == '__main__':
    Z=kcs_ui.real_req('key in Z coordinate', 7000)[1]
    H=kcs_ui.real_req('key in wall height', 2500)[1]
    component=kcs_ui.string_req('key in component name','WALLPAN-30')[1]
    point_ver=kcs_ui.int_req('verify points ? (1=YES, 0=NO)', 1)[1]
    wall_ver=kcs_ui.int_req('verify wall panels ? (1=YES, 0=NO)', 1)[1]
    Wall2Points(component, Z, H, point_ver, wall_ver)
      
